#include <string.h>
#include <stdio.h>
#include <stdlib.h>

#include "array.h"

void data_fastcgi_free(data_unset *d) {
	data_fastcgi *ds = (data_fastcgi *)d;
	
	buffer_free(ds->key);
	buffer_free(ds->host);
	buffer_free(ds->docroot);
	
	free(d);
}

void data_fastcgi_reset(data_unset *d) {
	data_fastcgi *ds = (data_fastcgi *)d;
	
	buffer_reset(ds->key);
	buffer_reset(ds->host);
	buffer_reset(ds->docroot);
	
}

int data_fastcgi_insert_dup(data_unset *dst, data_unset *src) {
	data_fastcgi *ds_dst = (data_fastcgi *)dst;
	data_fastcgi *ds_src = (data_fastcgi *)src;
	
	src->free(src);
	
	return 0;
}

void data_fastcgi_print(data_unset *d) {
	data_fastcgi *ds = (data_fastcgi *)d;
	
	printf("{%s: %s}", ds->key->ptr, ds->host->ptr);
}


data_fastcgi *data_fastcgi_init() {
	data_fastcgi *ds;
	
	ds = malloc(sizeof(data_fastcgi));
	memset(ds, 0, sizeof(data_fastcgi));
	
	ds->key = buffer_init();
	ds->host = buffer_init();
	ds->docroot = buffer_init();
	ds->port = 0;
	
	ds->free = data_fastcgi_free;
	ds->reset = data_fastcgi_reset;
	ds->insert_dup = data_fastcgi_insert_dup;
	ds->print = data_fastcgi_print;
	ds->type = TYPE_FASTCGI;
	
	return ds;
}
