#ifndef _NETWORK_BACKENDS_H_
#define _NETWORK_BACKENDS_H_

#include "config.h"

#if defined HAVE_SYS_SENDFILE_H && defined HAVE_SENDFILE && defined HAVE_WRITEV && defined(__linux__)
# define USE_LINUX_SENDFILE
# include <sys/sendfile.h>
# include <sys/uio.h>
#endif

#if defined HAVE_SYS_UIO_H && defined HAVE_SENDFILE && defined HAVE_WRITEV && defined(__freebsd__)
# define USE_FREEBSD_SENDFILE
# include <sys/sendfile.h>
# include <sys/uio.h>
#endif

#if defined HAVE_SYS_SENDFILE_H && defined HAVE_SENDFILEV && defined HAVE_WRITEV && defined(__sun)
# define USE_SOLARIS_SENDFILEV
# include <sys/sendfile.h>
# include <sys/uio.h>
#endif

#if defined HAVE_SYS_UIO_H && defined HAVE_WRITEV
# define USE_WRITEV
# include <sys/uio.h>
#endif

#if defined HAVE_SYS_MMAN_H && defined HAVE_MMAP
# define USE_MMAP
# include <sys/mman.h>
#endif

int network_write_chunkqueue_write(server *srv, connection *con, chunkqueue *cq);
int network_write_chunkqueue_writev(server *srv, connection *con, chunkqueue *cq);
int network_write_chunkqueue_linuxsendfile(server *srv, connection *con, chunkqueue *cq);
int network_write_chunkqueue_freebsdsendfile(server *srv, connection *con, chunkqueue *cq);
int network_write_chunkqueue_solarissendfilev(server *srv, connection *con, chunkqueue *cq);
int network_write_chunkqueue_openssl(server *srv, connection *con, chunkqueue *cq);

#endif
